
-- VHDL Test Bench Created from source file biquad_test1.vhd -- 17:41:09 03/05/2006
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY biquad_test1_biquad_tb2_vhd_tb IS
END biquad_test1_biquad_tb2_vhd_tb;

ARCHITECTURE behavior OF biquad_test1_biquad_tb2_vhd_tb IS 

	COMPONENT dap_core
	PORT(
		clk : IN std_logic;
		res : IN std_logic;
		fsm_din : IN std_logic_vector(7 downto 0);
		fsm_trg : IN std_logic;
		fsm_sel : IN std_logic;
		--input1 : IN std_logic_vector(23 downto 0);
		--input2 : IN std_logic_vector(23 downto 0);
		--new_smp : IN std_logic;          
		fsm_dout : OUT std_logic_vector(7 downto 0);
		fsm_rdy : OUT std_logic;
		fsm_inf : OUT std_logic_vector(15 downto 0);
		--output1 : OUT std_logic_vector(23 downto 0);
		--output2 : OUT std_logic_vector(23 downto 0)
		bclk  : in  std_logic;
		lrclk : in  std_logic;
		sdin1  : in  std_logic;
		sdout1 : out std_logic;
		sdin2  : in  std_logic;
		sdout2 : out std_logic
		);
	END COMPONENT;

	SIGNAL clk 			:  std_logic;
	SIGNAL res 			:  std_logic;
	SIGNAL input1 		:  std_logic_vector(31 downto 0);
	SIGNAL input2 		:  std_logic_vector(31 downto 0);
	SIGNAL output1 	:  std_logic_vector(31 downto 0);
	SIGNAL output2 	:  std_logic_vector(31 downto 0);


	constant T_RESET 		: time :=  1 ns;
	constant T_CLK_PER 	: time := 20 ns;
	
--	constant N_MULTIPLY_TO_SR : integer := 1042;  -- ca. 20.83 us => 48000kHz
 	constant N_MULTIPLY_TO_SR : integer := 1024;  -- fr simulation und test (geht schneller)
	
	SIGNAL value :  std_logic_vector (31 downto 0);
	SIGNAL incr  :  std_logic_vector (31 downto 0);	
	
	SIGNAL input_8_1   :  signed (7 downto 0);		
	SIGNAL input_8_2   :  signed (7 downto 0);		
	SIGNAL output_8_1  :  signed (7 downto 0);		
	SIGNAL output_8_2  :  signed (7 downto 0);		
	
	signal bclk  : std_logic;
	signal lrclk : std_logic;
	signal sdin1  : std_logic;
	signal sdout1 : std_logic;			
	signal sdin2  : std_logic;
	signal sdout2 : std_logic;			

   signal temp  : std_logic_vector (31 downto 0);
   
   signal temp2 : std_logic_vector (7 downto 0);   


BEGIN

	Inst_dap_core: dap_core PORT MAP(
		clk => clk,
		res => res,
		fsm_din => (others => '0'),
		fsm_dout => open,
		fsm_trg => '0',
		fsm_rdy => open,
		fsm_sel => '0',
		fsm_inf => open,
		bclk => bclk,
		lrclk => lrclk,
		sdin1 => sdin1,
		sdout1 => sdout1,
		sdin2 => sdin2,
		sdout2 => sdout2
	);

  clkgen : PROCESS
  BEGIN
      clk <= '0';
		wait for T_RESET;
		clkloop : loop
		  clk <= '1';
		  wait for T_CLK_PER / 2;
		  clk <= '0';		  
		  wait for T_CLK_PER / 2;
		end loop;
  END PROCESS;


	resgen : PROCESS
	BEGIN
	   res <= '1';
		wait for T_RESET;
		res <= '0';
	  wait; -- will wait forever
	END PROCESS;

	smpclkgen : PROCESS
	  variable cnt : integer range 0 to 63;
	begin
		wait for T_RESET;
		bclk <= '0';
		smpclkloop: loop
		    
          wait for (N_MULTIPLY_TO_SR / 128) * T_CLK_PER;
          bclk <= '1';
          wait for (N_MULTIPLY_TO_SR / 128) * T_CLK_PER;
          bclk <= '0';
		end loop;
	    
	end process;

	lrclkgen : PROCESS
	begin
		wait for T_RESET;
		lrclk <= '0';
		wait for (N_MULTIPLY_TO_SR / 64) * T_CLK_PER;
		lrclkloop: loop
		    
          wait for (N_MULTIPLY_TO_SR / 64) * 32 * T_CLK_PER;
          lrclk <= '1';
          wait for (N_MULTIPLY_TO_SR / 64) * 32 * T_CLK_PER;
          lrclk <= '0';
		end loop;
	    
	end process;

	datagen : PROCESS
	
	
	    procedure calc_sample is
	      variable temp  : std_logic_vector (31 downto 0);
	      variable temp8 : std_logic_vector ( 7 downto 0);
	        
	    begin
	     	value <= value + incr;
 		   	temp  := std_logic_vector (value) - X"80000000";
	     	if temp (31) = '1' then
          input1 <= X"ff" & temp (31) & temp (31 downto 9);
          input2 <= X"ff" & temp (31) & temp (31 downto 9);
        else  
          input1 <= X"00" & temp (31) & temp (31 downto 9);
          input2 <= X"00" & temp (31) & temp (31 downto 9);
       	end if;  
       	temp8 := std_logic_vector (input1 (23 downto 16)) + X"80";
       	input_8_1 <=  signed (temp8);
       	temp8 := std_logic_vector (input2 (23 downto 16)) + X"80";
       	input_8_2 <=  signed (temp8);
	    end calc_sample;   


	   
      procedure send_i2s (din1  : in  std_logic_vector (31 downto 0); 
                          din2  : in  std_logic_vector (31 downto 0); 
                          dout1 : out std_logic_vector (31 downto 0);
                          dout2 : out std_logic_vector (31 downto 0) ) is
        variable cnt  : integer range 0 to 23;
      begin 	

        for cnt in 0 to 23 loop
          wait for (N_MULTIPLY_TO_SR / 128) * T_CLK_PER;
          sdin1 <= din1 (23 - cnt);
          sdin2 <= din1 (23 - cnt);
          wait for (N_MULTIPLY_TO_SR / 128) * T_CLK_PER;
          dout1 (23 - cnt) := sdout1;
        end loop;  

        for cnt in 0 to 7 loop
          wait for (N_MULTIPLY_TO_SR / 128) * T_CLK_PER;
          sdin1 <= '0';
          sdin2 <= '0';
          wait for (N_MULTIPLY_TO_SR / 128) * T_CLK_PER;
        end loop;  
          
        for cnt in 0 to 23 loop
          wait for (N_MULTIPLY_TO_SR / 128) * T_CLK_PER;
          sdin1 <= din2 (23 - cnt);
          sdin2 <= din2 (23 - cnt);
          wait for (N_MULTIPLY_TO_SR / 128) * T_CLK_PER;
          dout2 (23 - cnt) := sdout1;
        end loop;  

        for cnt in 0 to 7 loop
          wait for (N_MULTIPLY_TO_SR / 128) * T_CLK_PER;
          sdin1 <= '0';
          sdin2 <= '0';
          wait for (N_MULTIPLY_TO_SR / 128) * T_CLK_PER;
        end loop;  
   
      end procedure;	  
       
	  variable temp : std_logic_vector (7 downto 0);  
	  variable out1, out2 : std_logic_vector ( 31 downto 0); 
	BEGIN
	   sdin1  <= '0'; 
	   sdin2  <= '0'; 
	    
	    
	   value  <= (others => '0');
	   incr   <= X"02580000";

		input1   <= X"00800000";
		input2   <= X"00800000";
		out1 		 := (others => '0');
		out2 		 := (others => '0');


	   
		wait for T_RESET;
		wait for (N_MULTIPLY_TO_SR / 64) * 2 * T_CLK_PER;
		send_i2s ( X"00000000" , X"00000000" , out1, out2);

      datagenloop : loop 

        calc_sample;
        send_i2s (std_logic_vector (input1), std_logic_vector (input2), out1, out2);

         output1 <= out1;
         output2 <= out2;
        
		  temp := std_logic_vector (output1 (23 downto 16)) - X"80";
		  output_8_1 <= signed (temp);
		  temp := std_logic_vector (output2 (23 downto 16)) - X"80";
		  output_8_2 <= signed (temp);        
        
      end loop;  

	END PROCESS;


END;
